// Photics-Physics-Bridge (PPB)
// Easier access to the Matter.js / Hype Physics API
// By Michael Garofalo — Photics © 2020-2021 👨🏻‍💻
// https://photics.com/
// Version 1.0
// Made in NYC 🗽
// Photics Public License (PPL)
// https://photics.com/books/a-book-about-hype/template-license-ppl/

// This project uses Matter.js Functions…
// matter-js by @liabru
// Copyright (c) Liam Brummitt and contributors
// https://brm.io/matter-js/
// License MIT – https://github.com/liabru/matter-js/blob/master/LICENSE

// This project uses Tumult Hype Functions…
// Tumult Hype
// Copyright © 2010-2021 Tumult Inc. All rights reserved.
// https://tumult.com/hype/


window.addEventListener("load", function () {
     hypeDocument = Object.values(HYPE.documents)[0];
});


window.ppb = {
     engine: function (e) {
          Matter.Engine(
               hypeDocument.getElementProperty(e, "physics-engine")
          )
     },
     getAngularVelocity: function (e, velocity) {
          Matter.Body.setAngularVelocity(
               hypeDocument.getElementProperty(
                    hypeDocument.getElementById(e), "physics-body"
               ), velocity
          );
     },
     getArea: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).area;
     },
     getPosition: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).position;
     },
     getSlop: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).slop;
     },
     getVelocity: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).velocity;
     },
     getX: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).position.x;
     },
     getY: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).position.y;
     },
     getXV: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).velocity.x;
     },
     getYV: function (e) {
          return hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).velocity.y;
     },
     inertia: function (e, inertia) {
          Matter.Body.setInertia(
               hypeDocument.getElementProperty(
                    hypeDocument.getElementById(e), "physics-body"
               ), inertia
          );
     },
     sensor: function (e, b) {
          hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).isSensor = b;
     },
     setAngle: function (e, degrees) {
          Matter.Body.setAngle(
               hypeDocument.getElementProperty(
                    hypeDocument.getElementById(e), "physics-body"
               ), Math.PI * (degrees / 180)
          );
     },
     setPosition: function (e, xPosition, yPosition) {
          Matter.Body.setPosition(
               hypeDocument.getElementProperty(
                    hypeDocument.getElementById(e), "physics-body"
               ), { x: xPosition, y: yPosition }
          );
     },
     setSlop: function (e, v) {
          hypeDocument.getElementProperty(
               hypeDocument.getElementById(e), "physics-body"
          ).slop = v;
     },
     setVelocity: function (e, xSpeed, ySpeed) {
          Matter.Body.setVelocity(
               hypeDocument.getElementProperty(
                    hypeDocument.getElementById(e), "physics-body"
               ), { x: xSpeed, y: ySpeed }
          );
     }

}